/*
 * Projectile, for player or enemy.
 */

// Floats some distance above the ground automatically.
// its z position should be on the ground usually

#include "gameobject.h"
#include "vector3d.h"

class Shot : public GameObject {
	public:
		Shot(Manager *m , Vect3d pos, Vect3d vel) : GameObject(m) { 
			velocity = vel;
			setLocation(pos);
			owner = 0;
			damage = 5.0;
			blownUp = false;
			blownUpTimer = 0;
			skull = false;
			solid = false;
		}
		virtual ~Shot() { }
		virtual void render();
		virtual void runLogic();
		void setDamage(Component d) { damage = d; }
		void setOwner(GameObject *o) { owner = o; }
		virtual void handleCollision(const Vect3d & overlap, GameObject *what);
		bool skull;
	protected:
		Component damage;
		GameObject *owner;
		Vect3d velocity;
		bool blownUp;
		int blownUpTimer;
		void blowUp();
};
