#include <allegro.h>
#include <iostream>
#include <assert.h>
#include <cstring>

using namespace std;
/*
 * Converter - strip borders from sprites.
 */

const int SpriteSize = 96;
const int ChopSize = 68;
 
int main(int argc, char *argv[])
{
	install_allegro(SYSTEM_NONE, &errno, atexit);
	if (argc < 2) {
		cerr << "not enough params" << endl;
		return 1;
	}
	PALETTE pal;
	set_color_conversion(COLORCONV_NONE);

	BITMAP *bmp = load_bitmap(argv[1], pal);
	assert(bmp != 0);
	// Create lots of little ones.
	int rows = bmp->h / SpriteSize;
	int cols = bmp->w / SpriteSize;
	int offset = (SpriteSize - ChopSize) / 2;
	BITMAP *newbmp = create_bitmap_ex(32, cols * ChopSize, rows * ChopSize);
	for (int j=0; j < rows; j++) {
		for (int i=0; i< cols; i++) {
			blit(bmp, newbmp,
				i* SpriteSize + offset,
				j* SpriteSize + offset,
				i* ChopSize,
				j* ChopSize,
				ChopSize,
				ChopSize);
			/*
			char filename[100];
			sprintf(filename, "chopped/%02d.tga", (j*cols) + i);
			// Junk palette.
			save_bitmap(filename, sub, pal);
			destroy_bitmap(sub);
			*/
		}
	}
	save_bitmap("chopped.tga", newbmp, pal);
	destroy_bitmap(newbmp);
	destroy_bitmap(bmp);
	return 0;
}
